# Support Vector Machines algorithm, with a hold out cross validation
# to determine the regularization parameter (package e1071)

cv.nbsvm <- function(X,y,gr,costs=10^seq(-2,3,length=10),K=10,scale=TRUE) {
  err.cv <- matrix(NA,K,length(costs)) ; nn <- length(y)
  folds <- split(sample(1:nn), rep(1:K, length = nn)) # cv.folds(nrow(X),K)
  for (i in 1:K) {
    ind <- folds[[i]]
    xtrain <- X[-ind,] ; ytrain <- y[-ind]
    xtest  <- X[ind,]  ; ytest  <- y[ind]
    for (j in 1:length(costs)) {
      o <- nbsvm(xtrain,ytrain,gr,Ctte=costs[j],scale=scale)
      err.cv[i,j] <- predict.nbsvm(o,xtest,ytest,scale=scale)$er
    }
  }
  merr <- apply(err.cv,2,mean)
  Copt <- costs[which.min(merr)]
  obj <- nbsvm(X,y,gr,Ctte=Copt)
  list(Copt=Copt,obj=obj)
}

