# Support Vector Machines algorithm, with a hold out cross validation
# to determine the regularization parameter (package e1071)

cv.stdsvm <- function(X,y,costs=10^seq(-2,3,length=10),K=10,scale=TRUE) {
  err.cv <- matrix(NA,K,length(costs)) ; nn <- length(y)
  folds <- split(sample(1:nn), rep(1:K, length = nn)) # cv.folds(nrow(X),K)
  for (i in 1:K) {
    ind <- folds[[i]]
    xtrain <- X[-ind,] ; ytrain <- y[-ind]
    xtest  <- X[ind,]  ; ytest  <- y[ind]
    for (j in 1:length(costs)) {
      o <- stdsvm(xtrain,ytrain,Ctte=costs[j],scale=scale)
      err.cv[i,j] <- predict.stdsvm(o,xtest,ytest,scale=scale)$er
    }
  }
  merr <- apply(err.cv,2,mean)
  Copt <- costs[which.min(merr)]
  obj <- stdsvm(X,y,Ctte=Copt)
  list(Copt=Copt,obj=obj)
}

